VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WallTiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain

Dim walltiles() As Integer

Dim iswalltile(1023, 1023) As Boolean

Public curwall As Integer
Public UsingWalltiles As Boolean

Private Sub Class_Initialize()
    ReDim walltiles(7, 15) As Integer
    
    curwall = 0
End Sub

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Function getWallTile(wallset As Integer, walltile As Integer) As Integer
    getWallTile = walltiles(wallset, walltile)
End Function

Sub setWallTile(wallset As Integer, walltile As Integer, tilenr As Integer)
    walltiles(wallset, walltile) = tilenr
End Sub

Sub setIsWallTile(x As Integer, y As Integer, Optional reset As Boolean = False)
    iswalltile(x, y) = Not reset
End Sub

Function getIsWallTile(x As Integer, y As Integer) As Boolean
    getIsWallTile = iswalltile(x, y)
End Function
Function tileconvert(tile As Integer)
'Converts tile position to walltile number
    Select Case tile
        Case 0
            tileconvert = 9
        Case 1
            tileconvert = 13
        Case 2
            tileconvert = 12
        Case 3
            tileconvert = 8
        Case 4
            tileconvert = 11
        Case 5
            tileconvert = 15
        Case 6
            tileconvert = 14
        Case 7
            tileconvert = 10
        Case 8
            tileconvert = 3
        Case 9
            tileconvert = 7
        Case 10
            tileconvert = 6
        Case 11
            tileconvert = 2
        Case 12
            tileconvert = 1
        Case 13
            tileconvert = 5
        Case 14
            tileconvert = 4
        Case 15
            tileconvert = 0
    End Select
End Function

Sub clearWallTile(wallset As Integer)
Dim i As Integer
    For i = 0 To 15
        walltiles(wallset, i) = 0
    Next
End Sub

Sub SetCurwall(newcurwall As Integer)
    curwall = newcurwall
End Sub



Function IsValidTileforWall(tilenr As Integer) As Boolean
Dim i As Integer
For i = 0 To 15
    If walltiles(curwall, i) <> 0 And walltiles(curwall, i) = tilenr Then
        IsValidTileforWall = True
        Exit Function
    End If
Next
IsValidTileforWall = False
End Function

Sub SaveWallTiles(path As String)
    On Error GoTo errh
    
    If Dir$(path) <> "" Then
        Kill path
    End If
    
    Dim f As Integer
    f = FreeFile
    Open path For Binary As #f
        Put #f, , walltiles
    Close #f
Exit Sub
errh:
    MsgBox "Error: " & Err & " " & Err.Description
End Sub

Sub LoadWallTiles(path As String)
    On Error GoTo errh
    Dim f As Integer
    f = FreeFile
    Open path For Binary As #f
        Get #f, , walltiles
    Close #f
    
Exit Sub
errh:
    MsgBox "Error: " & Err & " " & Err.Description
End Sub



Function DrawWallTile(x As Integer, y As Integer, Optional AdjustNeighbors As Boolean = True, Optional undoch As Changes, Optional onpreview As Boolean = True, Optional appendundo As Boolean = True) As Integer
    Dim val As Integer
    Dim tmp As Integer
    val = 0
    If x <= 1022 Then
        If (IsValidTileforWall(parent.getTile(x + 1, y)) And parent.pastetype <> p_under) Or iswalltile(x + 1, y) Then val = val + 1
        If AdjustNeighbors And parent.pastetype <> p_under And IsValidTileforWall(parent.getTile(x + 1, y)) And Not iswalltile(x + 1, y) Then
            Call setmaptile(x + 1, y, DrawWallTile(x + 1, y, False, undoch, onpreview), undoch, onpreview, appendundo)
        End If
    End If
    If y >= 1 Then
        If (IsValidTileforWall(parent.getTile(x, y - 1)) And parent.pastetype <> p_under) Or iswalltile(x, y - 1) Then val = val + 2
        If AdjustNeighbors And parent.pastetype <> p_under And IsValidTileforWall(parent.getTile(x, y - 1)) And Not iswalltile(x, y - 1) Then
            Call setmaptile(x, y - 1, DrawWallTile(x, y - 1, False, undoch, onpreview), undoch, onpreview, appendundo)
        End If
    End If
    If x >= 1 Then
        If (IsValidTileforWall(parent.getTile(x - 1, y)) And parent.pastetype <> p_under) Or iswalltile(x - 1, y) Then val = val + 4
        If AdjustNeighbors And parent.pastetype <> p_under And IsValidTileforWall(parent.getTile(x - 1, y)) And Not iswalltile(x - 1, y) Then
            Call setmaptile(x - 1, y, DrawWallTile(x - 1, y, False, undoch, onpreview), undoch, onpreview, appendundo)
        End If
    End If
    If y <= 1022 Then
        If (IsValidTileforWall(parent.getTile(x, y + 1)) And parent.pastetype <> p_under) Or iswalltile(x, y + 1) Then val = val + 8
        If AdjustNeighbors And parent.pastetype <> p_under And IsValidTileforWall(parent.getTile(x, y + 1)) And Not iswalltile(x, y + 1) Then
            Call setmaptile(x, y + 1, DrawWallTile(x, y + 1, False, undoch, onpreview), undoch, onpreview, appendundo)
        End If
    End If
    tmp = walltiles(curwall, val)
    
    If tmp <> 0 Then
        DrawWallTile = tmp
    Else
        tmp = parent.getTile(x, y)
        If tmp <> 0 And tmp <> -1 Then
            DrawWallTile = tmp
        Else
            Dim i As Integer
            For i = 0 To 15
                tmp = walltiles(curwall, i)
                If tmp <> 0 Then
                    DrawWallTile = tmp
                    Exit Function
                End If
            Next
            
            'There's not a single tile on that walltile set...
        End If
    End If
End Function

Sub ClearIsWallTile()
    Erase iswalltile
End Sub

Private Sub setmaptile(x As Integer, y As Integer, tilenr As Integer, undoch As Changes, Optional onpreview As Boolean = False, Optional appendundo As Boolean = True)
If Not onpreview Then
    Call parent.setTile(x, y, tilenr, undoch, appendundo)
    Call parent.UpdateLevelTile(x, y, False)
Else
    Dim lbx As Integer
    Dim lby As Integer
    lbx = Int(parent.hScr.value / (parent.currenttilew))
    lby = Int(parent.vScr.value / (parent.currenttilew))
    
    If Not parent.magnifier.UsingPixels Then
        BitBlt parent.picpreview.hdc, (x - lbx) * (parent.currenttilew), (y - lby) * (parent.currenttilew), (parent.currenttilew), (parent.currenttilew), parent.piczoomtileset.hdc, ((tilenr - 1) Mod 19) * (parent.currenttilew), Int((tilenr - 1) / 19) * (parent.currenttilew), vbSrcCopy
    Else
        Call SetPixel(parent.picpreview.hdc, (x - lbx), (y - lby), TilePixelColor(tilenr))
    End If
End If
End Sub


Function isvalidset(wallset As Integer) As Boolean
Dim i As Integer
For i = 0 To 15
    If walltiles(wallset, i) <> 0 Then
        isvalidset = True
        Exit Function
    End If
Next
isvalidset = False
End Function
